package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.Org;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class OrgSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<Org> selectCond;
	private JSONObject customsearchval;
	public OrgSearchFilter(){
		this.page =new Page<Org>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<Org>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_orgname_like;

	public void setN_orgname_like(String n_orgname_like) {
        this.n_orgname_like = n_orgname_like;
        if(!StringUtils.isEmpty(this.n_orgname_like)){
            this.selectCond.like("orgname", n_orgname_like);
        }
    }
	private String n_porgid_eq;

	public void setN_porgid_eq(String n_porgid_eq) {
        this.n_porgid_eq = n_porgid_eq;
        if(!StringUtils.isEmpty(this.n_porgid_eq)){
            this.selectCond.eq("porgid", n_porgid_eq);
        }
    }
	private String n_porgname_eq;

	public void setN_porgname_eq(String n_porgname_eq) {
        this.n_porgname_eq = n_porgname_eq;
        if(!StringUtils.isEmpty(this.n_porgname_eq)){
            this.selectCond.eq("porgname", n_porgname_eq);
        }
    }
	private String n_porgname_like;

	public void setN_porgname_like(String n_porgname_like) {
        this.n_porgname_like = n_porgname_like;
        if(!StringUtils.isEmpty(this.n_porgname_like)){
            this.selectCond.like("porgname", n_porgname_like);
        }
    }
	private String n_shortname_like;

	public void setN_shortname_like(String n_shortname_like) {
        this.n_shortname_like = n_shortname_like;
        if(!StringUtils.isEmpty(this.n_shortname_like)){
            this.selectCond.like("shortname", n_shortname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_ORG_ORG_PORGID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_porgid_eq("NA");
			}
			else{
				this.setN_porgid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("orgname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}